<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <base-card class="formStyling">
    <div v-if="isLoading">
      <base-spinner></base-spinner>
    </div>
    <div v-else-if="!isLoading">
      <h2>Jaka akcja została podjęta</h2>
      <form @submit.prevent="submitNewStatus">
        <div class="form-control">
          <label for="status">Wybierz akcję </label>
          <select id="status" name="status" v-model="status">
            <option
              v-for="status in statutes"
              :key="status['id']"
              :value="status['id']"
            >
              {{ status["status"] }}
            </option>
          </select>
        </div>
        <div class="button">
          <base-button>Zatwierdź akcję</base-button>
        </div>
      </form>
    </div>
  </base-card>
</template>

<script setup>
import { defineProps, onMounted, ref } from "vue";
import { useStore } from "vuex";

const props = defineProps(["reportId", "statusId"]);

const error = ref(null);
const isLoading = ref(false);
const status = ref("");
const statutes = ref([]);

const store = useStore();

function handleError() {
  error.value = null;
}

function loadReports() {
  statutes.value = store.getters.reportStatutes;
  statutes.value = statutes.value.filter(
    (status) => status["status"] !== "nowe"
  );
  statutes.value = statutes.value.filter(
    (status) => status["id"] !== props.statusId
  );
  status.value = statutes.value[0]["id"];
}

async function submitNewStatus() {
  isLoading.value = true;
  try {
    await store.dispatch("setStatus", {
      reportId: props.reportId,
      statusId: status.value,
    });
    loadReports();
  } catch (er) {
    error.value = "Nie udało się ustawić statusu raportu.";
  }
  isLoading.value = false;
}

onMounted(async function () {
  loadReports();
});
</script>
